#!/usr/bin/env python
from os import listdir
from os.path import isfile, join
import gzip
import re

tag='_70_t10'
p= '0.3,0.7'
path="./experiments_current_1"

# (1) get all the files
allfiles = [fname for fname in listdir(path) if isfile(join(path, fname))]
print "files:"+str(len(allfiles))

# (2) read each file and generate reopt for each seed
for filename in allfiles:
	print filename
	# get filename -> outputfilename and read content
	mo = re.match(r'^.*_n([0-9][0-9]*)[^0-9].*w([0-9][0-9]*)[^0-9].*l([0-9][0-9]*)[^0-9].*$',filename, re.M|re.I)
	if mo != None:
        	n = int(mo.group(1))
		w = int(mo.group(2))
		l = int(mo.group(3))

		out_filename='input_sidechain_from_'+filename+'_n'+str(n)+'_w'+str(w)+'_l'+str(l)+'_'+tag

		#FIXME : some added criterion
		if n == 4 and (l == 64 or l == 50) and w <= 16 and w >= 16:
			print "->"+out_filename
			with open(join(path,filename)) as f:
				content = f.readlines()

			cut_every = 40000 // (w*w*n*n*l) + 1

			# (2.2) get all seeds
			seeds = []
			i = 0
			for line in content:
				i += 1
				# memorize all the seeds before the ": commandline"
				mo2 = re.match(r'^(1[10,]*)[ \t].*$',line,re.M|re.I)
				if mo2 != None:
					seeds.append(mo2.group(1))
				# cut into several jobs
				if i % cut_every == 0:
					print str(i//cut_every)
					with open(out_filename+"_"+str(i//cut_every),'w') as of:
						of.write("::CHECK: starting ...\n")
						for seed in seeds:
							s = str(int(w)+20)
							for ls in content:
								of.write(ls)
							of.write(": -spaced -BSymbols 01 -f " + p + " -b 0.5,0.5 -n " + str(n) + " -w " + str(w) + "," + str(w) + " -s " + str(w) + "," + str(s) +  " -l " + str(l) + " -p -r 10000 -k -m " + seed + "\n")
						seeds = []
			# end cut
			if i % cut_every != 0:
				with open(out_filename+"_end",'w') as of:
					of.write("::CHECK: starting ...\n")
					for seed in seeds:
						s = str(int(w)+20)
						for ls in content:
							of.write(ls)
						of.write(": -spaced -BSymbols 01 -f " + p + " -b 0.5,0.5 -n " + str(n) + " -w " + str(w) + "," + str(w) + " -s " + str(w) + "," + str(s) +  " -l " + str(l) + " -p -r 10000 -k -m " + seed + "\n")
					seeds = []
